const path = require('path');

module.exports = function(tsconfig, tsconfigPath) {
  const mutableConfig = { ...tsconfig };
  const setterConfig = {};
  const ignoredConfigOptions = [];
  let isAutosave = false;

  function updateConfig() {
    const writtenConfig = { ...mutableConfig };
    for (const ignoredConfigOption of ignoredConfigOptions) {
      eval(`delete writtenConfig.${ignoredConfigOption}`);
    }
    fs.writeFileSync(tsconfigPath, JSON5.stringify(writtenConfig, null, 2));
  }

  function createSettersConfig(mc, sc) {
    for (const key in mc) {
      if (typeof mc[key] === 'object') {
        sc[key] = {};
        createSettersConfig(mc[key], sc[key]);
      } else {
        Object.defineProperty(sc, key, {
          get() {
            return mc[key];
          },
          set(value) {
            mc[key] = value;
            if (isAutosave) updateConfig();
          }
        });
      }
    }
  }

  createSettersConfig(mutableConfig, setterConfig);
  return {
    ...setterConfig,
    directory: path.dirname(tsconfigPath),
    path: tsconfigPath,
    ignore: function(configOption) {
      ignoredConfigOptions.push(configOption);
      updateConfig();
    },
    save: updateConfig,
    autosave: function(isAutosave) {
      isAutosave = isAutosave;
    }
  };
}